<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SaveSiparisKargoPaket StructType
 * @subpackage Structs
 */
class SaveSiparisKargoPaket extends AbstractStructBase
{
    /**
     * The UyeKodu
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UyeKodu;
    /**
     * The SiparisID
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $SiparisID;
    /**
     * The SiparisUrunDurumID
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $SiparisUrunDurumID;
    /**
     * The KargoEntegrasyonID
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $KargoEntegrasyonID;
    /**
     * The Urunler
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfint
     */
    public $Urunler;
    /**
     * The KargoTakipNo
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $KargoTakipNo;
    /**
     * The KontrolEtme
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $KontrolEtme;
    /**
     * Constructor method for SaveSiparisKargoPaket
     * @uses SaveSiparisKargoPaket::setUyeKodu()
     * @uses SaveSiparisKargoPaket::setSiparisID()
     * @uses SaveSiparisKargoPaket::setSiparisUrunDurumID()
     * @uses SaveSiparisKargoPaket::setKargoEntegrasyonID()
     * @uses SaveSiparisKargoPaket::setUrunler()
     * @uses SaveSiparisKargoPaket::setKargoTakipNo()
     * @uses SaveSiparisKargoPaket::setKontrolEtme()
     * @param string $uyeKodu
     * @param int $siparisID
     * @param int $siparisUrunDurumID
     * @param int $kargoEntegrasyonID
     * @param \ArrayType\ArrayOfint $urunler
     * @param string $kargoTakipNo
     * @param bool $kontrolEtme
     */
    public function __construct($uyeKodu = null, $siparisID = null, $siparisUrunDurumID = null, $kargoEntegrasyonID = null, \ArrayType\ArrayOfint $urunler = null, $kargoTakipNo = null, $kontrolEtme = null)
    {
        $this
            ->setUyeKodu($uyeKodu)
            ->setSiparisID($siparisID)
            ->setSiparisUrunDurumID($siparisUrunDurumID)
            ->setKargoEntegrasyonID($kargoEntegrasyonID)
            ->setUrunler($urunler)
            ->setKargoTakipNo($kargoTakipNo)
            ->setKontrolEtme($kontrolEtme);
    }
    /**
     * Get UyeKodu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUyeKodu()
    {
        return isset($this->UyeKodu) ? $this->UyeKodu : null;
    }
    /**
     * Set UyeKodu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $uyeKodu
     * @return \StructType\SaveSiparisKargoPaket
     */
    public function setUyeKodu($uyeKodu = null)
    {
        // validation for constraint: string
        if (!is_null($uyeKodu) && !is_string($uyeKodu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($uyeKodu)), __LINE__);
        }
        if (is_null($uyeKodu) || (is_array($uyeKodu) && empty($uyeKodu))) {
            unset($this->UyeKodu);
        } else {
            $this->UyeKodu = $uyeKodu;
        }
        return $this;
    }
    /**
     * Get SiparisID value
     * @return int|null
     */
    public function getSiparisID()
    {
        return $this->SiparisID;
    }
    /**
     * Set SiparisID value
     * @param int $siparisID
     * @return \StructType\SaveSiparisKargoPaket
     */
    public function setSiparisID($siparisID = null)
    {
        // validation for constraint: int
        if (!is_null($siparisID) && !is_numeric($siparisID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($siparisID)), __LINE__);
        }
        $this->SiparisID = $siparisID;
        return $this;
    }
    /**
     * Get SiparisUrunDurumID value
     * @return int|null
     */
    public function getSiparisUrunDurumID()
    {
        return $this->SiparisUrunDurumID;
    }
    /**
     * Set SiparisUrunDurumID value
     * @param int $siparisUrunDurumID
     * @return \StructType\SaveSiparisKargoPaket
     */
    public function setSiparisUrunDurumID($siparisUrunDurumID = null)
    {
        // validation for constraint: int
        if (!is_null($siparisUrunDurumID) && !is_numeric($siparisUrunDurumID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($siparisUrunDurumID)), __LINE__);
        }
        $this->SiparisUrunDurumID = $siparisUrunDurumID;
        return $this;
    }
    /**
     * Get KargoEntegrasyonID value
     * @return int|null
     */
    public function getKargoEntegrasyonID()
    {
        return $this->KargoEntegrasyonID;
    }
    /**
     * Set KargoEntegrasyonID value
     * @param int $kargoEntegrasyonID
     * @return \StructType\SaveSiparisKargoPaket
     */
    public function setKargoEntegrasyonID($kargoEntegrasyonID = null)
    {
        // validation for constraint: int
        if (!is_null($kargoEntegrasyonID) && !is_numeric($kargoEntegrasyonID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($kargoEntegrasyonID)), __LINE__);
        }
        $this->KargoEntegrasyonID = $kargoEntegrasyonID;
        return $this;
    }
    /**
     * Get Urunler value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfint|null
     */
    public function getUrunler()
    {
        return isset($this->Urunler) ? $this->Urunler : null;
    }
    /**
     * Set Urunler value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfint $urunler
     * @return \StructType\SaveSiparisKargoPaket
     */
    public function setUrunler(\ArrayType\ArrayOfint $urunler = null)
    {
        if (is_null($urunler) || (is_array($urunler) && empty($urunler))) {
            unset($this->Urunler);
        } else {
            $this->Urunler = $urunler;
        }
        return $this;
    }
    /**
     * Get KargoTakipNo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKargoTakipNo()
    {
        return isset($this->KargoTakipNo) ? $this->KargoTakipNo : null;
    }
    /**
     * Set KargoTakipNo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $kargoTakipNo
     * @return \StructType\SaveSiparisKargoPaket
     */
    public function setKargoTakipNo($kargoTakipNo = null)
    {
        // validation for constraint: string
        if (!is_null($kargoTakipNo) && !is_string($kargoTakipNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($kargoTakipNo)), __LINE__);
        }
        if (is_null($kargoTakipNo) || (is_array($kargoTakipNo) && empty($kargoTakipNo))) {
            unset($this->KargoTakipNo);
        } else {
            $this->KargoTakipNo = $kargoTakipNo;
        }
        return $this;
    }
    /**
     * Get KontrolEtme value
     * @return bool|null
     */
    public function getKontrolEtme()
    {
        return $this->KontrolEtme;
    }
    /**
     * Set KontrolEtme value
     * @param bool $kontrolEtme
     * @return \StructType\SaveSiparisKargoPaket
     */
    public function setKontrolEtme($kontrolEtme = null)
    {
        // validation for constraint: boolean
        if (!is_null($kontrolEtme) && !is_bool($kontrolEtme)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($kontrolEtme)), __LINE__);
        }
        $this->KontrolEtme = $kontrolEtme;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SaveSiparisKargoPaket
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
